Subject: bug#43835: 28.0.50; auto-hscroll-mode/current-line + show-paren-mode + gnus-summary-mode = bug

From: Stephen Berman <[email-masked]>
Date: Thu, 08 Oct 2020 14:24:17 +0200

On Thu, 08 Oct 2020 14:55:58 +0300 Eli Zaretskii <[email-masked]> wrote:

>> From: Stephen Berman <[email-masked]>
>> Cc: [email-masked]
>> Date: Thu, 08 Oct 2020 12:18:55 +0200
>>
>> I can see the problem is a real .el file, but it seems to depend on the
>> form of the line and other conditions I don't understand.  I visited
>> bindings.el and added the following line (with no line break, in case
>> one gets added to it in the email) at the end of the file:
>
> Like I said: this happens when the problematic line is either the very
> first or the very last line of the buffer.  I think you are describing
> the latter situation?

Yes (that is, the last nonempty line -- but I have not seen the problem
on the first line if there are nonempty lines below it, nor if there is
more than one empty line at the end).

>> (setq bla "Subject: Re: bug#39280: 27.0.60; wdired-get-filename ignores
>> first argument")
>>
>> Then I added a newline, evaluated (setq auto-hscroll-mode 'current-line
>> truncate-lines t) and enabled show-paren-mode.  With point at the
>> beginning of the above line I typed `C-e' and the line scrolled left and
>> the end of the line remained visible, i.e., no problem.  Then I deleted
>> the final `)', typed `C-a C-e' and the line scrolled left and then
>> immediately undid the hscroll so the end of the line was not visible but
>> after a fraction of a second it scrolled left again and the end of the
>> line remained visible.  Then I additionally deleted the final `"', typed
>> `C-a C-e' and the line scrolled left and now the end of the line
>> remained out of view indefinitely.  This even though the final line does
>> now does not end with a parenthesis group, in contrast to all previous
>> cases where I've seen the problem.  And indeed, if I restart the
>> experiment in a fresh emacs -Q and insert just `(setq bla "Subject: Re:
>> bug#39280: 27.0.60; wdired-get-filename ignores first argument' --
>> i.e. without the closing `")' -- plus a newline and make the other
>> necessary settings, then I see no hscrolling problem.  Can you replicate
>> these observations?
>
> I don't see them after fixing the problem.  Is it still necessary to
> see if they existed before the fix?

No, with your fix all the test cases I've tried now show the correct
behavior.

On Thu, 08 Oct 2020 14:53:12 +0300 Eli Zaretskii <[email-masked]> wrote:

>> Date: Thu, 08 Oct 2020 12:10:15 +0300
>> From: Eli Zaretskii <[email-masked]>
>> Cc: [email-masked]
>>
>> OK, so I think the conditions for triggering the problem are well
>> understood, and we both have the same observations, thanks.
>
> Should be fixed now on the emacs-27 branch, I think.

Confirmed, and many thanks!  Feel free to close the bug.

Steve Berman